blob: 9f198267494fb03cadb3202a38b94b2beebf1328 [file] [log] [blame]
Petr Michalec1ed1b3c2017-08-08 19:19:01 +02001#!/bin/bash -e
2
3# bootstrap.sh
4
5# Installs Salt and configure minimal SaltMaster or Minion to be used with:
6# - http://github.com/salt-formulas-scripts
7# - http://github.com/salt-formulas/salt-formula-salt (salt.master sls)
8
Petr Michalecca2471f2018-03-17 11:17:32 +01009# NOTE: This script is collection of shared functions to automate bootstrap of "salted" CI environments.
10# Its not intended to be used in PRODUCTION unless you know what you are doing.
11# You have been warned!
Petr Michalec1ed1b3c2017-08-08 19:19:01 +020012
13# Source specific env vars.
14# shopt -u dotglob
15export RECLASS_ROOT=${RECLASS_ROOT:-/srv/salt/reclass}
16function source_local_envs() {
Petr Michalecb444ef92017-08-17 13:53:14 +020017 for path in / /tmp/kitchen /srv/salt . ${RECLASS_ROOT}/classes/cluster ${RECLASS_ROOT}/classes/cluster/${CLUSTER_NAME}; do
Vasyl Saienko7a4161c2017-08-14 17:43:15 +030018 for f in $(find $path -maxdepth 1 -name '*.env' 2> /dev/null); do
19 echo "Sourcing env variables from $f"
20 source $f
21 done
22 done
Petr Michalec1ed1b3c2017-08-08 19:19:01 +020023}
24source_local_envs
25
26##########################################
27# Set defaults env variables
28
29if [[ $DEBUG =~ ^(True|true|1|yes)$ ]]; then
30 set -x
31 SALT_LOG_LEVEL="--state-verbose=true -ldebug"
32fi
33
34export MAGENTA='\033[0;95m'
35export YELLOW='\033[1;33m'
36export BLUE='\033[0;35m'
37export CYAN='\033[0;96m'
38export RED='\033[0;31m'
39export NC='\033[0m' # No Color'
40
41export LC_ALL=C
42export SALT_LOG_LEVEL="--state-verbose=false -lerror"
43export SALT_OPTS="${SALT_OPTS:- --timeout=120 --state-output=changes --retcode-passthrough --force-color $SALT_LOG_LEVEL }"
44export SALT_STATE_RETRY=${SALT_STATE_RETRY:-3}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +020045
Petr Michalec1ed1b3c2017-08-08 19:19:01 +020046# salt apt repository
47test -e /etc/lsb-release && eval $(cat /etc/lsb-release)
48which lsb_release && DISTRIB_CODENAME=${DISTRIB_CODENAME:-$(lsb_release -cs)}
49#
Dmitry Ukov95492a02017-10-23 11:34:45 +040050export APT_REPOSITORY=${APT_REPOSITORY:- deb [arch=amd64] http://apt.mirantis.com/${DISTRIB_CODENAME} ${DISTRIB_REVISION:-stable} salt}
chnyda30c07a62017-09-20 14:28:02 +020051export APT_REPOSITORY_GPG=${APT_REPOSITORY_GPG:-http://apt.mirantis.com/public.gpg}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +020052# reclass
53export RECLASS_ADDRESS=${RECLASS_ADDRESS:-https://github.com/salt-formulas/openstack-salt.git} # https/git
ibumarskovf72e05e2017-11-29 14:37:48 +030054export RECLASS_BRANCH=${RECLASS_BRANCH:-master}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +020055
56# formula
57export FORMULAS_BASE=${FORMULAS_BASE:-https://github.com/salt-formulas}
58export FORMULAS_PATH=${FORMULAS_PATH:-/usr/share/salt-formulas}
59export FORMULAS_BRANCH=${FORMULAS_BRANCH:-master}
60export FORMULAS_SOURCE=${FORMULAS_SOURCE:-pkg} # pkg/git
Petr Michalec515356f2017-11-16 11:20:20 +010061# Essential set of formulas (known to by used on cfg01 node for most setups during bootsrap)
62# DEPRECATED: FORMULAS_SALT_MASTER=${FORMULAS_SALT_MASTER:- $EXTRA_FORMULAS maas memcached ntp nginx collectd sensu heka sphinx mysql grafana libvirt rsyslog glusterfs postfix xtrabackup freeipa prometheus telegraf elasticsearch kibana rundeck devops-portal rsync docker keepalived aptly jenkins gerrit artifactory influxdb horizon}
Petr Michalece07cd0b2017-11-15 11:41:57 +010063FORMULAS_SALT_MASTER=${FORMULAS_SALT_MASTER:- $EXTRA_FORMULAS}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +020064# minimal set of formulas for salt-master bootstrap
Petr Michalec515356f2017-11-16 11:20:20 +010065declare -a FORMULAS_SALT_MASTER=(reclass salt git openssh linux $(echo $FORMULAS_SALT_MASTER))
Petr Michalec1ed1b3c2017-08-08 19:19:01 +020066export FORMULAS_SALT_MASTER
67
68# system / host
Petr Michalecc749e862017-09-06 21:10:10 +020069export HOSTNAME=${HOSTNAME:-`hostname -s`}
70export HOSTNAME=${HOSTNAME//.*/}
71export DOMAIN=${DOMAIN:-`hostname -d`}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +020072export DOMAIN=${DOMAIN:-bootstrap.local}
73
74# salt
Petr Michalec1ed1b3c2017-08-08 19:19:01 +020075export MINION_ID=${MINION_ID:-${HOSTNAME}.${DOMAIN}}
Petr Michalec2e3a4992017-08-17 14:20:43 +020076export MASTER_HOSTNAME=${MASTER_HOSTNAME:-${HOSTNAME}.${DOMAIN}}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +020077
78# saltstack
Petr Michalec33c04892017-09-08 15:10:30 +020079BOOTSTRAP_SALTSTACK=${BOOTSTRAP_SALTSTACK:-True}
alexz0adc2712018-02-11 17:33:52 +010080BOOTSTRAP_SALTSTACK_COM=${BOOTSTRAP_SALTSTACK_COM:-"https://bootstrap.saltstack.com"}
Petr Michalece11cf612017-09-08 18:21:48 +020081BOOTSTRAP_SALTSTACK_VERSION=${BOOTSTRAP_SALTSTACK_VERSION:- stable 2016.3 }
Jakub Josef0b611742018-01-09 17:02:01 +010082BOOTSTRAP_SALTSTACK_VERSION=${BOOTSTRAP_SALTSTACK_VERSION//latest*/stable}
alexz0adc2712018-02-11 17:33:52 +010083# TODO add 'r' option by default
84# Currently, without 'r' option, upstream saltstack repos will be used. Otherwise
85# local one should be used, from http://apt.mirantis.com/ or whatever.
Petr Michalec33c04892017-09-08 15:10:30 +020086BOOTSTRAP_SALTSTACK_OPTS=${BOOTSTRAP_SALTSTACK_OPTS:- -dX $BOOTSTRAP_SALTSTACK_VERSION }
Petr Michalece11cf612017-09-08 18:21:48 +020087SALT_SOURCE=${SALT_SOURCE:-pkg}
88# the version below is used salt pillar data
89SALT_VERSION=${SALT_VERSION:-latest}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +020090
Petr Michalecca2471f2018-03-17 11:17:32 +010091# SECURITY
92SSH_STRICTHOSTKEYCHECKING=no
93
Petr Michalec1ed1b3c2017-08-08 19:19:01 +020094# environment
95if [ "$FORMULAS_SOURCE" == "git" ]; then
96 SALT_ENV=${SALT_ENV:-dev}
97elif [ "$FORMULAS_SOURCE" == "pkg" ]; then
98 SALT_ENV=${SALT_ENV:-prd}
99fi
Petr Michalec05b52452017-09-08 14:26:59 +0200100eval "$(grep -h '=' /etc/*release 2> /dev/null)"
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200101PLATFORM_FAMILY=$(echo ${ID_LIKE// */} | tr A-Z a-z)
102case $PLATFORM_FAMILY in
103 debian )
104 PKGTOOL="$SUDO apt-get"
105 test ${VERSION_ID//\.*/} -ge 16 && {
106 SVCTOOL=service
107 } || { SVCTOOL=service
108 }
109 ;;
110 rhel )
111 PKGTOOL="$SUDO yum"
112 test ${VERSION_ID//\.*/} -ge 7 && {
113 SVCTOOL=systemctl
114 } || { SVCTOOL=service
115 }
116 ;;
117esac
118
119export PLATFORM_FAMILY
120export PKGTOOL
121export SVCTOOL
122
123##########################################
124# FUNCTIONS
125
126log_info() {
127 echo -e "${YELLOW}[INFO] $* ${NC}"
128}
129
130log_warn() {
131 echo -e "${MAGENTA}[WARN] $* ${NC}"
132}
133
Petr Michalec24b30e82017-08-21 10:59:18 +0200134log_debug() {
135 echo -e "${CYAN}[WARN] $* ${NC}"
136}
137
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200138log_err() {
139 echo -e "${RED}[ERROR] $* ${NC}" >&2
140}
141
142configure_pkg_repo()
143{
144
145 case $PLATFORM_FAMILY in
146 debian)
147 if [ -n "$APT_REPOSITORY_PPA" ]; then
148 which add-apt-repository || $SUDO apt-get install -y software-properties-common
149 $SUDO add-apt-repository -y ppa:${APT_REPOSITORY_PPA}
150 else
Mykyta Karpinfbcb5482017-10-04 14:15:25 +0300151 echo -e "$APT_REPOSITORY " | $SUDO tee /etc/apt/sources.list.d/mcp_salt.list >/dev/null
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200152 curl -sL $APT_REPOSITORY_GPG | $SUDO apt-key add -
153 fi
154 $SUDO apt-get clean
155 $SUDO apt-get update
156 ;;
157 rhel)
158 $SUDO yum install -y https://repo.saltstack.com/yum/redhat/salt-repo-latest-1.el${VERSION_ID}.noarch.rpm
159 $SUDO yum clean all
160 ;;
161 esac
162
163}
164
165_atexit() {
166 RETVAL=$?
167 trap true INT TERM EXIT
168
169 if [ $RETVAL -ne 0 ]; then
170 log_err "Execution failed"
171 else
172 log_info "Execution successful"
173 fi
174 return $RETVAL
175}
176
177retry() {
178 local tries
179 if [[ $1 =~ ^[0-9]+$ ]]; then
180 tries=$1; shift
181 else
182 tries=3
183 fi
Petr Michalec262e3ad2017-10-06 13:41:58 +0200184 ret=1
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200185 for i in $(seq 1 $tries); do
Petr Michalec262e3ad2017-10-06 13:41:58 +0200186 "$@" && return $? || ret=$?
187 sleep $i
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200188 done
Petr Michalec9fec8b32017-10-05 14:46:42 +0200189 return $ret
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200190}
191
192function clone_reclass() {
Petr Michaleca361d4e2017-09-08 11:38:16 +0200193 if [ ! -d ${RECLASS_ROOT}/classes ]; then
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200194 # No reclass at all, clone from given address
alexz0adc2712018-02-11 17:33:52 +0100195 # In case, non-github repo
196 _tmp_host=$(echo ${RECLASS_ADDRESS} | awk -F/ '{print $3}')
197 ssh-keyscan -T 1 -H ${_tmp_host} >> ~/.ssh/known_hosts || true
198 # But, awk is not perfect solution, so lets make double-check for github
199 ssh-keyscan -T 1 -H github.com >> ~/.ssh/known_hosts || true
ibumarskovf72e05e2017-11-29 14:37:48 +0300200 if echo ${RECLASS_BRANCH} | egrep -q "^refs"; then
201 git clone ${RECLASS_ADDRESS} ${RECLASS_ROOT}
202 cd ${RECLASS_ROOT}
203 git fetch ${RECLASS_ADDRESS} ${RECLASS_BRANCH} && git checkout FETCH_HEAD
204 export RECLASS_REVISION=$(git rev-parse HEAD)
205 cd -
206 else
207 git clone -b ${RECLASS_BRANCH} ${RECLASS_ADDRESS} ${RECLASS_ROOT};
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200208 fi;
209 fi;
Petr Michalec679f15b2017-09-18 16:16:29 +0200210 if [ ! -d ${RECLASS_ROOT}/classes ]; then
Petr Michaleca361d4e2017-09-08 11:38:16 +0200211 log_err "Reclass ${RECLASS_ROOT} is not fetched locally;"
212 ls -Rla ${RECLASS_ROOT}
213 exit 1
214 fi;
215 $SUDO mkdir -p $RECLASS_ROOT/classes/service
216 $SUDO mkdir -p $RECLASS_ROOT/nodes/_generated
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200217}
218
219
220##########################################
221# Main calls
222
Petr Michalecca2471f2018-03-17 11:17:32 +0100223ci_config_ssh() {
224
225 # for CI current user
226 conf=~/.ssh/config
227 mkdir -p $(dirname $conf)
228 touch $conf
229 echo -e "Host *\n\tStrictHostKeyChecking $SSH_STRICTHOSTKEYCHECKING\n" | tee -a $conf >/dev/null
230 touch ~/.ssh/known_hosts
231
Petr Michalecda014202017-08-18 11:26:07 +0200232 if ! grep github.com ~/.ssh/known_hosts; then
233 ssh-keyscan -H github.com >> ~/.ssh/known_hosts || true
Petr Michalecca2471f2018-03-17 11:17:32 +0100234 ssh-keyscan -H gitlab.com >> ~/.ssh/known_hosts || true
Petr Michalecda014202017-08-18 11:26:07 +0200235 fi
Petr Michalecca2471f2018-03-17 11:17:32 +0100236
237 # for root
238 #conf=/root/.ssh/config
239 #$SUDO mkdir -p $(dirname $conf)
240 #$SUDO touch $conf
241 #if ! $SSH_STRICTHOSTKEYCHECKING; then
242 # echo -e "Host *\n\tStrictHostKeyChecking no\n" | $SUDO tee -a $conf >/dev/null
243 #fi
244}
245
246# DEPRECATED
247system_config_ssh_conf() {
248 # for backward compatibility
249 ci_config_ssh
Petr Michalecda014202017-08-18 11:26:07 +0200250}
251
252system_config_salt_modules_prereq() {
253 # salt-formulas custom modules dependencies, etc:
254 $SUDO $PKGTOOL install -y iproute2 curl sudo apt-transport-https python-psutil python-apt python-m2crypto python-oauth python-pip &>/dev/null
255}
256
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200257system_config_minion() {
258 log_info "System configuration salt minion"
259}
260
261system_config_master() {
262 log_info "System configuration salt master"
263
Petr Michalecda014202017-08-18 11:26:07 +0200264 system_config_salt_modules_prereq
Petr Michalecca2471f2018-03-17 11:17:32 +0100265 ci_config_ssh
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200266
Petr Michalecda014202017-08-18 11:26:07 +0200267 if ! grep '127.0.1.2.*salt' /etc/hosts; then
268 echo "127.0.1.2 salt" | $SUDO tee -a /etc/hosts >/dev/null
269 fi
Petr Michalecbebd7d52018-03-16 22:14:05 +0100270
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200271}
272
273configure_salt_master()
274{
275
276 echo "Configuring salt-master ..."
277
Petr Michalec4be5e5b2017-08-17 11:44:49 +0200278 if [[ $RECLASS_IGNORE_CLASS_NOTFOUND =~ ^(True|true|1|yes)$ ]]; then
Petr Michalec29d3ea32017-10-31 17:22:36 +0100279 read -d '' IGNORE_CLASS_NOTFOUND <<-EOF
280 ignore_class_notfound: True
281 ignore_class_regexp:
282 - 'service.*'
283EOF
Petr Michalec4be5e5b2017-08-17 11:44:49 +0200284 fi
285
Petr Michalecdd1a0472017-09-06 19:27:24 +0200286 # to force alternative reclass module path
Petr Michalecd9d0a322017-09-06 19:38:32 +0200287 if [ -n "$RECLASS_SOURCE_PATH" ]; then
288 RECLASS_SOURCE_PATH="reclass_source_path: ${RECLASS_SOURCE_PATH}"
289 else
290 RECLASS_SOURCE_PATH=""
291 fi
Petr Michalecdd1a0472017-09-06 19:27:24 +0200292
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200293 [ ! -d /etc/salt/master.d ] && mkdir -p /etc/salt/master.d
294 cat <<-EOF > /etc/salt/master.d/master.conf
295 file_roots:
296 base:
297 - /usr/share/salt-formulas/env
298 prd:
299 - /srv/salt/env/prd
300 dev:
301 - /srv/salt/env/dev
302 pillar_opts: False
303 open_mode: True
304 reclass: &reclass
305 storage_type: yaml_fs
306 inventory_base_uri: ${RECLASS_ROOT}
Petr Michalec4be5e5b2017-08-17 11:44:49 +0200307 ${IGNORE_CLASS_NOTFOUND}
Petr Michalecdd1a0472017-09-06 19:27:24 +0200308 ${RECLASS_SOURCE_PATH}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200309 ext_pillar:
310 - reclass: *reclass
311 master_tops:
312 reclass: *reclass
313EOF
314
315 echo "Configuring reclass ..."
316
317 [ ! -d /etc/reclass ] && mkdir /etc/reclass
318 cat <<-EOF > /etc/reclass/reclass-config.yml
319 storage_type: yaml_fs
320 pretty_print: True
321 output: yaml
322 inventory_base_uri: ${RECLASS_ROOT}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200323EOF
324
325 clone_reclass
326 # override some envs from cluster level *.env, use with care
327 source_local_envs
328
329 cd ${RECLASS_ROOT}
330 if [ ! -d ${RECLASS_ROOT}/classes/system/linux ]; then
331 # Possibly subrepo checkout needed
332 git submodule update --init --recursive
333 fi
334
Petr Michalec212cc6a2017-08-17 21:39:40 +0200335 mkdir -vp ${RECLASS_ROOT}/nodes/_generated
Petr Michalec51ece842017-09-06 20:44:15 +0200336 rm -rvf ${RECLASS_ROOT}/nodes/_generated/*
337
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200338 CONFIG=$(find ${RECLASS_ROOT}/nodes -name ${MINION_ID}.yml| grep yml | tail -n1)
Petr Michalec212cc6a2017-08-17 21:39:40 +0200339 CONFIG=${CONFIG:-${RECLASS_ROOT}/nodes/_generated/${MINION_ID}.yml}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200340 if [[ $SALT_MASTER_BOOTSTRAP_MINIMIZED =~ ^(True|true|1|yes)$ || ! -f "${CONFIG}" ]]; then
Petr Michalec24b30e82017-08-21 10:59:18 +0200341 log_warn "Salt Master node specification has not been found in model."
342 log_warn "Creating temporary cfg01 configuration for bootstrap: ${CONFIG}"
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200343 cat <<-EOF > ${CONFIG}
344 classes:
Petr Michalecd81d1f52017-08-17 20:18:06 +0200345 - cluster.${CLUSTER_NAME}.infra.config
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200346 parameters:
347 _param:
Petr Michaleca7de6df2017-08-31 12:16:57 +0200348 salt_master_host: ${MASTER_IP:-$MASTER_HOSTNAME}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200349 salt_master_base_environment: $SALT_ENV
Petr Michalecd81d1f52017-08-17 20:18:06 +0200350 salt_formula_branch: ${SALT_FORMULAS_BRANCH:-master}
ibumarskovf72e05e2017-11-29 14:37:48 +0300351 reclass_data_revision: ${RECLASS_REVISION:-$RECLASS_BRANCH}
Petr Michalecd81d1f52017-08-17 20:18:06 +0200352 reclass_data_repository: "$RECLASS_ADDRESS"
Petr Michaleca7de6df2017-08-31 12:16:57 +0200353 reclass_config_master: ${MASTER_IP:-$MASTER_HOSTNAME}
Petr Michalecd81d1f52017-08-17 20:18:06 +0200354 linux_system_codename: ${DISTRIB_CODENAME}
355 cluster_name: ${CLUSTER_NAME}
356 cluster_domain: ${DOMAIN:-$CLUSTER_NAME.local}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200357 linux:
358 system:
Petr Michalecd81d1f52017-08-17 20:18:06 +0200359 name: ${HOSTNAME:-cfg01}
360 domain: ${DOMAIN:-$CLUSTER_NAME.local}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200361 # ########
362EOF
363
364 if [ "$SALT_VERSION" == "latest" ]; then
365 VERSION=""
366 else
367 VERSION="version: $SALT_VERSION"
368 fi
369
370 cat <<-EOF >> ${CONFIG}
371 salt:
372 master:
373 accept_policy: open_mode
374 source:
375 engine: $SALT_SOURCE
376 $VERSION
377 minion:
378 source:
379 engine: $SALT_SOURCE
380 $VERSION
381 # ########
382 # vim: ft=yaml sw=2 ts=2 sts=2
383EOF
384 fi
Petr Michalec24b30e82017-08-21 10:59:18 +0200385
386 log_debug "Salt Master node config yaml:"
387 log_debug "$(cat ${CONFIG})"
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200388}
389
390configure_salt_minion()
391{
392 [ ! -d /etc/salt/minion.d ] && mkdir -p /etc/salt/minion.d
393 cat <<-EOF > /etc/salt/minion.d/minion.conf
Petr Michaleca7de6df2017-08-31 12:16:57 +0200394 master: ${MASTER_IP:-$MASTER_HOSTNAME}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200395 id: $MINION_ID
396 EOF
397}
398
Petr Michaleca6cd2bd2017-09-07 16:59:19 +0200399install_reclass()
400{
401 VERSION=${1:-$RECLASS_VERSION}
Petr Michalec372fa032017-11-15 17:36:19 +0100402 VERSION=${VERSION:-pkg}
Petr Michalec800dd072017-11-15 17:19:26 +0100403 case ${VERSION} in
404 pkg|package)
405 which reclass || $SUDO $PKGTOOL install -y reclass
rootb9e5d7c2018-03-17 12:12:44 +0000406 which reclass-salt || {
407 if [ -e /usr/share/reclass/reclass-salt ]; then
408 ln -fs /usr/share/reclass/reclass-salt /usr/bin
409 fi
410 }
Petr Michalec800dd072017-11-15 17:19:26 +0100411 ;;
412 *)
Petr Michalec981f3cc2017-11-15 17:40:31 +0100413 log_warn "Install development version of reclass"
Petr Michalec1b37d3d2017-11-15 18:20:46 +0100414 # Note: dev/git/pip version...
415 # It replaces all local reclass versions on system
416 # Required for reclass/git features:
417 # $SUDO $PKGTOOL install -y libffi-dev libgit2-dev || true
Petr Michalec800dd072017-11-15 17:19:26 +0100418 for s in $(python -c "import site; print(' '.join(site.getsitepackages()))"); do
Petr Michalec23020832017-11-15 17:34:49 +0100419 sudo -H pip install --install-option="--prefix=" --upgrade --force-reinstall -I \
Petr Michalec800dd072017-11-15 17:19:26 +0100420 -t "$s" git+https://github.com/salt-formulas/reclass.git@${VERSION};
421 done
422 ;;
423 esac
Petr Michaleca6cd2bd2017-09-07 16:59:19 +0200424}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200425
426install_salt_master_pkg()
427{
428 echo -e "\nPreparing base OS repository ...\n"
429
430 configure_pkg_repo
431
432 echo -e "\nInstalling salt master ...\n"
433
434 case $PLATFORM_FAMILY in
435 debian)
436 $SUDO apt-get install -y git
alexz0adc2712018-02-11 17:33:52 +0100437 curl -L ${BOOTSTRAP_SALTSTACK_COM} | $SUDO sh -s -- -M ${BOOTSTRAP_SALTSTACK_OPTS} &>/dev/null || true
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200438 ;;
439 rhel)
440 yum install -y git
alexz0adc2712018-02-11 17:33:52 +0100441 curl -L ${BOOTSTRAP_SALTSTACK_COM} | $SUDO sh -s -- -M ${BOOTSTRAP_SALTSTACK_OPTS} &>/dev/null || true
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200442 ;;
443 esac
Jakub Josef0b611742018-01-09 17:02:01 +0100444
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200445 configure_salt_master
446
447 echo -e "\nRestarting services ...\n"
448 [ -f /etc/salt/pki/minion/minion_master.pub ] && rm -f /etc/salt/pki/minion/minion_master.pub
449 $SVCTOOL salt-master restart
450}
451
452install_salt_master_pip()
453{
454 echo -e "\nPreparing base OS repository ...\n"
455
456 case $PLATFORM_FAMILY in
457 debian)
458 $SUDO apt-get install -y python-pip python-dev zlib1g-dev git
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200459 ;;
460 rhel)
461 $SUDO yum install -y git
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200462 ;;
463 esac
464
465 echo -e "\nInstalling salt master ...\n"
466 # TODO: replace with saltstack bootstrap script
Jakub Josef0b611742018-01-09 17:02:01 +0100467
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200468 if [ "$SALT_VERSION" == "latest" ]; then
469 pip install salt
470 else
471 pip install salt==$SALT_VERSION
472 fi
473
474 curl -Lo /etc/init.d/salt-master https://anonscm.debian.org/cgit/pkg-salt/salt.git/plain/debian/salt-master.init && chmod 755 /etc/init.d/salt-master
475 ln -s /usr/local/bin/salt-master /usr/bin/salt-master
476
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200477 configure_salt_master
478
479 echo -e "\nRestarting services ...\n"
480 [ -f /etc/salt/pki/minion/minion_master.pub ] && rm -f /etc/salt/pki/minion/minion_master.pub
481 $SVCTOOL salt-master restart
482}
483
484
485
486install_salt_minion_pkg()
487{
488
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200489 echo -e "\nInstalling salt minion ...\n"
490
491 case $PLATFORM_FAMILY in
492 debian)
alexz0adc2712018-02-11 17:33:52 +0100493 curl -L ${BOOTSTRAP_SALTSTACK_COM} | $SUDO sh -s -- ${BOOTSTRAP_SALTSTACK_OPTS} &>/dev/null || true
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200494 ;;
495 rhel)
alexz0adc2712018-02-11 17:33:52 +0100496 curl -L ${BOOTSTRAP_SALTSTACK_COM} | $SUDO sh -s -- ${BOOTSTRAP_SALTSTACK_OPTS} &>/dev/null || true
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200497 ;;
498 esac
499
500
501 configure_salt_minion
Petr Michalec3b7fdd82017-09-08 15:35:56 +0200502 #$SVCTOOL salt-minion restart
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200503}
504
505install_salt_minion_pip()
506{
507 echo -e "\nInstalling salt minion ...\n"
508
509 curl -Lo /etc/init.d/salt-minion https://anonscm.debian.org/cgit/pkg-salt/salt.git/plain/debian/salt-minion.init && chmod 755 /etc/init.d/salt-minion
510 ln -s /usr/local/bin/salt-minion /usr/bin/salt-minion
511
512 configure_salt_minion
Petr Michalec3b7fdd82017-09-08 15:35:56 +0200513 #$SVCTOOL salt-minion restart
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200514}
515
516
517install_salt_formula_pkg()
518{
519 configure_pkg_repo
520
521 case $PLATFORM_FAMILY in
522 debian)
523 echo "Configuring necessary formulas ..."
524
525 [ ! -d ${RECLASS_ROOT}/classes/service ] && mkdir -p ${RECLASS_ROOT}/classes/service
526 # Set essentials if FORMULAS_SALT_MASTER is not defined at all
Petr Michalec2d753972017-11-30 16:24:37 +0100527 [ -z ${FORMULAS_SALT_MASTER} ] && declare -a FORMULAS_SALT_MASTER=("linux" "reclass" "salt" "memcached")
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200528 for formula_service in "${FORMULAS_SALT_MASTER[@]}"; do
529 echo -e "\nConfiguring salt formula ${formula_service} ...\n"
530 [ ! -d "${FORMULAS_PATH}/env/${formula_service}" ] && \
531 if ! $SUDO apt-get install -y salt-formula-${formula_service}; then
532 echo -e "\nInstall salt-formula-${formula_service} failed.\n"
533 exit 1
534 fi
535 [ ! -L "${RECLASS_ROOT}/classes/service/${formula_service}" ] && \
536 ln -sf ${FORMULAS_PATH}/reclass/service/${formula_service} ${RECLASS_ROOT}/classes/service/${formula_service}
537 done
538 ;;
539 rhel)
540 # TODO
541 ;;
542 esac
543
544 [ ! -d /srv/salt/env ] && mkdir -p /srv/salt/env || echo ""
545 [ ! -L /srv/salt/env/prd ] && ln -s ${FORMULAS_PATH}/env /srv/salt/env/prd || echo ""
546}
547
548install_salt_formula_git()
549{
550 echo "Configuring necessary formulas ..."
551
552 [ ! -d ${RECLASS_ROOT}/classes/service ] && mkdir -p ${RECLASS_ROOT}/classes/service
553 # Set essentials if FORMULAS_SALT_MASTER is not defined at all
Petr Michalec2d753972017-11-30 16:24:37 +0100554 [ -z ${FORMULAS_SALT_MASTER} ] && declare -a FORMULAS_SALT_MASTER=("linux" "reclass" "salt" "memcached")
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200555 for formula_service in "${FORMULAS_SALT_MASTER[@]}"; do
556 echo -e "\nConfiguring salt formula ${formula_service} ...\n"
557 _BRANCH=${FORMULAS_BRANCH}
558 [ ! -d "${FORMULAS_PATH}/env/_formulas/${formula_service}" ] && {
559 if ! git ls-remote --exit-code --heads ${FORMULAS_BASE}/salt-formula-${formula_service}.git ${_BRANCH}; then
560 # Fallback to the master branch if the branch doesn't exist for this repository
561 _BRANCH=master
562 fi
563 if ! git clone ${FORMULAS_BASE}/salt-formula-${formula_service}.git ${FORMULAS_PATH}/env/_formulas/${formula_service} -b ${_BRANCH}; then
564 echo -e "\nCloning of ${FORMULAS_BASE}/salt-formula-${formula_service}.git failed.\n"
565 exit 1
566 fi
567 } || {
568 cd ${FORMULAS_PATH}/env/_formulas/${formula_service};
569 git fetch origin/${_BRANCH} || git fetch --all
570 git checkout ${_BRANCH} && git pull || git pull;
571 cd -
572 }
573 [ ! -L "/usr/share/salt-formulas/env/${formula_service}" ] && \
574 ln -sf ${FORMULAS_PATH}/env/_formulas/${formula_service}/${formula_service} /usr/share/salt-formulas/env/${formula_service}
575 [ ! -L "${RECLASS_ROOT}/classes/service/${formula_service}" ] && \
576 ln -sf ${FORMULAS_PATH}/env/_formulas/${formula_service}/metadata/service ${RECLASS_ROOT}/classes/service/${formula_service}
577 done
578
579 [ ! -d /srv/salt/env ] && mkdir -p /srv/salt/env || echo ""
580 [ ! -L /srv/salt/env/dev ] && ln -s /usr/share/salt-formulas/env /srv/salt/env/dev || echo ""
581}
582
Petr Michalece9c84522017-12-13 17:14:08 +0100583saltservice_stop() {
Petr Michalecdd646db2017-12-18 15:56:18 +0100584 set +e
Petr Michalece9c84522017-12-13 17:14:08 +0100585 $SUDO service salt-minion stop
586 $SUDO service salt-master stop
587 sleep ${SALT_STOPSTART_WAIT:-30}
Petr Michalec7822efe2017-12-15 16:19:32 +0100588 ${SUDO} pkill -9 salt-master && ${SUDO} rm -rf /var/run/salt/master/* || true
Petr Michalece9c84522017-12-13 17:14:08 +0100589 ${SUDO} pkill -9 salt-minion
590}
591saltservice_start() {
Petr Michalecdd646db2017-12-18 15:56:18 +0100592 set +e
Petr Michalece9c84522017-12-13 17:14:08 +0100593 $SUDO service salt-master start
594 $SUDO service salt-minion start
595 sleep ${SALT_STOPSTART_WAIT:-30}
596}
597
598saltservice_restart() {
Petr Michalecdd646db2017-12-18 15:56:18 +0100599 set +e
Petr Michalece9c84522017-12-13 17:14:08 +0100600 saltservice_stop
601 saltservice_start
602}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200603
604saltmaster_bootstrap() {
605
606 log_info "Salt master setup"
607 test -n "$MASTER_HOSTNAME" || exit 1
608
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200609 # override some envs from cluster level *.env, use with care
610 source_local_envs
611
Petr Michalece9c84522017-12-13 17:14:08 +0100612 saltservice_stop
613
614 clone_reclass
615
projoke3c30e7d2017-10-19 17:15:40 +0800616 SCRIPTS=$(dirname $0)
Petr Michalece9c84522017-12-13 17:14:08 +0100617
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200618 test -e ${SCRIPTS}/.salt-master-setup.sh.passed || {
Adam Tengler035f24f2017-09-11 19:29:31 +0200619 export MASTER_IP=${MASTER_IP:-127.0.0.1}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200620 export MINION_ID=${MASTER_HOSTNAME}
621 if ! [[ $DEBUG =~ ^(True|true|1|yes)$ ]]; then
622 SALT_MASTER_SETUP_OUTPUT='/dev/stdout'
623 fi
624 # call local "setup() master"
625 #if ! $SUDO ${SCRIPTS}/salt-master-setup.sh master &> ${SALT_MASTER_SETUP_OUTPUT:-/tmp/salt-master-setup.log}; then
626 if ! setup master; then
627 #cat /tmp/salt-master-setup.log
628 log_err "salt master setup() failed."
629 exit 1
630 else
631 $SUDO touch ${SCRIPTS}/.salt-master-setup.sh.passed
632 fi
633 }
634
Petr Michalec981f3cc2017-11-15 17:40:31 +0100635 log_info "Install reclass"
636 install_reclass ${RECLASS_VERSION/dev*/develop}
Petr Michaleca6cd2bd2017-09-07 16:59:19 +0200637
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200638 log_info "Re/starting salt services"
Petr Michalece9c84522017-12-13 17:14:08 +0100639 saltservice_restart
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200640}
641
642# Init salt master
643saltmaster_init() {
644
645 log_info "Runing saltmaster states"
646 test -n "$MASTER_HOSTNAME" || exit 1
647
648 set -e
649 $SUDO salt-call saltutil.sync_all >/dev/null
650
Petr Michalecda014202017-08-18 11:26:07 +0200651 # workarond isolated and not fully bootstraped environments
Petr Michalec2801acb2017-10-31 15:00:15 +0100652 if [[ $RECLASS_IGNORE_CLASS_NOTFOUND =~ ^(True|true|1|yes)$ ]]; then
Petr Michalec54ee4082017-11-30 17:02:17 +0100653 SALT_MASTER_PILLAR='"salt":{"master":{"pillar":{"reclass":{"ignore_class_notfound": '${RECLASS_IGNORE_CLASS_NOTFOUND:-False}', "ignore_class_regexp": ["service.*"]}}}},'
Petr Michalec2801acb2017-10-31 15:00:15 +0100654 fi
Petr Michalec8ce8a652017-11-30 15:39:20 +0100655 PILLAR='{'${SALT_MASTER_PILLAR}' "reclass":{"storage":{"data_source":{"engine":"local"}}} }'
Petr Michalecda014202017-08-18 11:26:07 +0200656
Petr Michalec8b92d552017-11-29 12:28:50 +0100657 log_info "State: salt.master.env,salt.master.pillar"
Petr Michalec54ee4082017-11-30 17:02:17 +0100658 if ! $SUDO salt-call ${SALT_OPTS} state.apply salt.master.env,salt.master.pillar pillar="$PILLAR"; then
Petr Michalec85ef7ad2017-11-30 15:21:19 +0100659 log_err "State \`salt.master.env,salt.master.pillar pillar=$PILLAR\` failed, keep your eyes wide open!"
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200660 fi
661
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200662 # Revert temporary SaltMaster minimal configuration, if any
663 pushd $RECLASS_ROOT
664 if [ $(git diff --name-only nodes | sort | uniq | wc -l) -ge 1 ]; then
Petr Michalec87778fc2017-11-02 10:13:25 +0100665 PILLAR='{"reclass":{"storage":{"data_source":{"engine":"local"}}} }'
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200666 git status || true
Petr Michalecda014202017-08-18 11:26:07 +0200667 log_warn "Locally modified $RECLASS_ROOT/nodes found. (Possibly salt-master minimized setup from bootstrap.sh call)"
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200668 log_info "Checkout HEAD state of $RECLASS_ROOT/nodes/*."
669 git checkout -- $RECLASS_ROOT/nodes || true
670 log_info "Re-Run states: salt.master.env and salt.master.pillar according the HEAD state."
Petr Michalec7edf8322017-11-30 12:01:09 +0100671 log_info "State: salt.master.env,salt.master.pillar"
Petr Michalec54ee4082017-11-30 17:02:17 +0100672 if ! $SUDO salt-call ${SALT_OPTS} state.apply salt.master.env,salt.master.pillar pillar="$PILLAR"; then
Petr Michalec85ef7ad2017-11-30 15:21:19 +0100673 log_err "State \`salt.master.env,salt.master.pillar pillar=$PILLAR\` failed, keep your eyes wide open!"
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200674 fi
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200675 fi
676 popd
677
Petr Michalecda014202017-08-18 11:26:07 +0200678 # finally re-configure salt master conf, ie: may remove ignore_class_notfound option
679 log_info "State: salt.master.service"
Jakub Josef32563412018-01-17 17:55:05 +0100680 # ensure salt master is started
681 saltservice_start
Petr Michalec9fec8b32017-10-05 14:46:42 +0200682 retry ${SALT_STATE_RETRY} $SUDO salt-call ${SALT_OPTS} state.apply salt.master.service || true
Petr Michalec4f043772017-12-19 15:40:54 +0100683 saltservice_start
Petr Michalecda014202017-08-18 11:26:07 +0200684
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200685 log_info "State: salt.master.storage.node"
686 set +e
Petr Michalec7edf8322017-11-30 12:01:09 +0100687 # TODO: PLACEHOLDER TO TRIGGER NODE GENERATION THROUG SALT REACT.
688 # FIXME: PLACEHOLDER TO TRIGGER NODE GENERATION THROUG SALT REACT.
Petr Michalec9fec8b32017-10-05 14:46:42 +0200689 retry ${SALT_STATE_RETRY} $SUDO salt-call ${SALT_OPTS} state.apply reclass.storage.node
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200690 ret=$?
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200691
Petr Michalecdd646db2017-12-18 15:56:18 +0100692 set -e
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200693 if [[ $ret -eq 2 ]]; then
694 log_err "State reclass.storage.node failed with exit code 2 but continuing."
695 elif [[ $ret -ne 0 ]]; then
696 log_err "State reclass.storage.node failed with exit code $ret"
697 exit 1
698 fi
699
Petr Michalecdd646db2017-12-18 15:56:18 +0100700 set +e
701 log_info "Updating minion.conf -> master: localhost"
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200702 $SUDO sed -i 's/^master:.*/master: localhost/' /etc/salt/minion.d/minion.conf
Petr Michalecdd646db2017-12-18 15:56:18 +0100703
704 log_info "Re/starting salt services" # in order to load new deployed configuration from model
Petr Michalece9c84522017-12-13 17:14:08 +0100705 saltservice_restart
Petr Michalecdd646db2017-12-18 15:56:18 +0100706
707 log_info "Salt Util sync all"
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200708 $SUDO salt-call ${SALT_OPTS} saltutil.sync_all >/dev/null
709
710 verify_salt_master
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200711
712}
713
714
715function verify_salt_master() {
716 set -e
717
718 log_info "Verify Salt master"
719 test -n "$MASTER_HOSTNAME" || exit 1
720
721 if [[ $VERIFY_SALT_CALL =~ ^(True|true|1|yes)$ ]]; then
Petr Michaleca5141342017-08-16 12:55:20 +0200722 $SUDO salt-call ${SALT_OPTS} --id=${MASTER_HOSTNAME} reclass.validate_yaml > /tmp/${MASTER_HOSTNAME}.reclass.validate_yaml
723 $SUDO salt-call ${SALT_OPTS} --id=${MASTER_HOSTNAME} reclass.validate_pillar > /tmp/${MASTER_HOSTNAME}.reclass.validate_pillar
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200724 $SUDO salt-call ${SALT_OPTS} --id=${MASTER_HOSTNAME} grains.item roles > /tmp/${MASTER_HOSTNAME}.grains.item.roles
725 $SUDO salt-call ${SALT_OPTS} --id=${MASTER_HOSTNAME} state.show_lowstate > /tmp/${MASTER_HOSTNAME}.state.show_state
726 $SUDO salt-call --no-color grains.items
727 $SUDO salt-call --no-color pillar.data
728 fi
Petr Michaleca5141342017-08-16 12:55:20 +0200729 # TODO: REMOVE reclass --nodeinfo section / run only on debug - as the only required is reclass.validate_*
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200730 if ! $SUDO reclass --nodeinfo ${MASTER_HOSTNAME} > /tmp/${MASTER_HOSTNAME}.reclass.nodeinfo; then
731 log_err "For more details see full log /tmp/${MASTER_HOSTNAME}.reclass.nodeinfo"
732 exit 1
733 fi
Petr Michalec7edf8322017-11-30 12:01:09 +0100734 set +e
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200735}
736
737function verify_salt_minion() {
738 set -e
739 node=$1
740 log_info "Verifying ${node}"
741 if [[ $VERIFY_SALT_CALL =~ ^(True|true|1|yes)$ ]]; then
742 $SUDO salt-call ${SALT_OPTS} --id=${node} grains.item roles > /tmp/${node}.grains.item.roles
743 $SUDO salt-call ${SALT_OPTS} --id=${node} state.show_lowstate > /tmp/${node}.state.show_lowstate
744 fi
745 if ! $SUDO reclass --nodeinfo ${node} > /tmp/${node}.reclass.nodeinfo; then
746 log_err "For more details see full log /tmp/${node}.reclass.nodeinfo"
747 if [[ ${BREAK_ON_VERIFICATION_ERROR:-yes} =~ ^(True|true|1|yes)$ ]]; then
748 exit 1
749 fi
750 fi
Petr Michalec7edf8322017-11-30 12:01:09 +0100751 set +e
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200752}
753
754function verify_salt_minions() {
755 #set -e
Petr Michalec679f15b2017-09-18 16:16:29 +0200756 NODES=$(find $RECLASS_ROOT/nodes/_generated/ -name "*.yml" | grep -v "cfg")
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200757 log_info "Verifying minions: $(echo ${NODES}|xargs)"
758
759 # Parallel
760 #echo $NODES | parallel --no-notice -j 2 --halt 2 "verify_salt_minion \$(basename {} .yml) > {}.pillar_verify"
761 #ls -lrta *.pillar_verify | tail -n 1 | xargs -n1 tail -n30
762
763 function filterFails() {
764 grep -v '/grains' | tee -a $1 | tail -n20
765 }
766
767 log_info "Verify nodes"
768 passed=0
769 for node in ${NODES}; do
770 node=$(basename $node .yml)
771
772 # filter first in cluster.. ctl-01, mon-01, etc..
773 if [[ "${node//.*}" =~ 01 || "${node//.*}" =~ 02 ]] ;then
774 verify_salt_minion ${node} || continue
775 else
776 echo Skipped $node.
777 fi
778 passed=$(($passed+1))
779 done
780 # fail on failures
781 total=$(echo $NODES | xargs --no-run-if-empty -n1 echo |wc -l)
782 test ! $passed -lt $total || log_err "Results: $passed of $total passed."
783 test ! $passed -lt $total || {
784 tail -n50 /tmp/*.pillar_verify
785 return 1
786 }
Petr Michalec7edf8322017-11-30 12:01:09 +0100787 #set +e
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200788}
789
790
791
792##########################################
793# To install salt master/minon
794
795function install() {
796 setup $@
797}
798
799function setup() {
800 # CLI
801 while [ x"$1" != x"" ]; do
802 which curl &>/dev/null || $PKGTOOL -y install curl &>/dev/null
803
804 case $1 in
805 master )
806 install_salt_master_$SALT_SOURCE
807 install_salt_minion_$SALT_SOURCE
808 install_salt_formula_$FORMULAS_SOURCE
809 ;;
810 minion )
811 install_salt_minion_$SALT_SOURCE
812 ;;
813 esac
814 shift
815 done
816 echo DONE
817}
818
819function bootstrap() {
820 log_info "Bootstrap & verification of SaltMaster and configured minions."
821 trap _atexit INT TERM EXIT
822
823 system_config_master
824 saltmaster_bootstrap &&\
Petr Michalec58575b92017-08-20 10:42:25 +0200825 saltmaster_init #&&\
Petr Michaleca5141342017-08-16 12:55:20 +0200826 #verify_salt_minions
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200827}
828
829function default() {
830 bootstrap $@
831}
832
833
834##########################################
835[[ "$0" != "$BASH_SOURCE" ]] || {
836# unless file is being sourced
837 default $@
838}